#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityDoubleElevenMission.h"
std::auto_ptr<M_ActivityDoubleElevenMission> M_ActivityDoubleElevenMission::msSingleton(nullptr);

int M_ActivityDoubleElevenMission::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityDoubleElevenMissionData* M_ActivityDoubleElevenMission::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityDoubleElevenMissionData>& M_ActivityDoubleElevenMission::GetMapData()
{
	return mMapData;
}

void M_ActivityDoubleElevenMission::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityDoubleElevenMission.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityDoubleElevenMissionData data;
		data.mID = element->IntAttribute("ID");
		data.mDesc = element->Attribute("Desc");
		data.mCompleteType = element->IntAttribute("CompleteType");
		data.mCompleteParam = element->IntAttribute("CompleteParam");
		data.mCompleteCount = element->IntAttribute("CompleteCount");
		data.mItemID = element->IntAttribute("ItemID");
		data.mItemCount = element->IntAttribute("ItemCount");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityDoubleElevenMission Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityDoubleElevenMission::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityDoubleElevenMission");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityDoubleElevenMission");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityDoubleElevenMissionData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "Desc", data.mDesc);
		LuaCfgHelper::readInt(L, "CompleteType", data.mCompleteType);
		LuaCfgHelper::readInt(L, "CompleteParam", data.mCompleteParam);
		LuaCfgHelper::readInt(L, "CompleteCount", data.mCompleteCount);
		LuaCfgHelper::readInt(L, "ItemID", data.mItemID);
		LuaCfgHelper::readInt(L, "ItemCount", data.mItemCount);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityDoubleElevenMission Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityDoubleElevenMission::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityDoubleElevenMission* M_ActivityDoubleElevenMission::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityDoubleElevenMission());
	}
	return msSingleton.get();
}

void M_ActivityDoubleElevenMission::Release()
{
	msSingleton.reset(nullptr);
}
